$ ======================================================================
$
$   TOPPERS/HRP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       High Reliable system Profile Kernel
$
$   Copyright (C) 2007-2012 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$  
$   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
$   ܥեȥѤΤޤࡥʲƱˤѡʣ
$   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
$   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
$       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
$       ˴ޤޤƤ뤳ȡ
$   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
$       ѤǤǺۤˤϡۤȼɥȡ
$       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
$       ̵ݾڵǺܤ뤳ȡ
$   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
$       ѤǤʤǺۤˤϡΤ줫ξ
$       ȡ
$     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
$         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
$     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
$         𤹤뤳ȡ
$   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
$       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
$       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
$       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
$       դ뤳ȡ
$  
$   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
$   TOPPERSץȤϡܥեȥ˴ؤơλŪ
$   ФŬޤơʤݾڤԤʤޤܥեȥ
$   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
$   Ǥʤ
$
$  
$ =====================================================================

$INCLUDE "cfg2_out.tf"$

$
$  ݸɥᥤΥ٥κ
$	DOM.LABEL[domid]ݸɥᥤΥ٥
$
$DOM.LABEL[TDOM_KERNEL] = "kernel"$
$FOREACH domid DOM.ID_LIST$
	$DOM.LABEL[domid] = domid$
$END$
$DOM.LABEL[TDOM_NONE] = "shared"$

$ 
$  ݸɥᥤΥǥեȤΥĥѥκ
$ 
$DEFAULT_ACPTN[TDOM_KERNEL] = VALUE("TACP_KERNEL", TACP_KERNEL)$
$FOREACH domid DOM.ID_LIST$
	$DEFAULT_ACPTN[domid] = VALUE(FORMAT("TACP(%1%)", domid), 1 << (domid - 1))$
$END$
$DEFAULT_ACPTN[TDOM_NONE] = VALUE("TACP_SHARED", TACP_SHARED)$

$ MO_CLASS_LIST
$ ݸ°Ʊꥪ֥ȤޤȤ᤿ꥹ
$prev = -1$
$FOREACH memtop MO_START_LIST$
    $IF (prev != -1)$
        $prev_idx = FIND(MO_ORDER, prev)$
        $curr_idx = FIND(MO_ORDER, memtop)$
        $IF (!LENGTH(prev_idx) || !LENGTH(curr_idx))$
            $ERROR$$FORMAT("error: cannot find mo %d", prev_idx)$$END$
        $ELSE$
            $WHILE (prev_idx < curr_idx)$
                $MO_CLASS_LIST[prev] = APPEND(MO_CLASS_LIST[prev], AT(MO_ORDER, prev_idx))$
                $prev_idx = prev_idx + 1$
            $END$
        $END$
    $END$

    $prev = memtop$
$END$

$moid = AT(MO_ORDER, curr_idx)$
$WHILE (curr_idx < LENGTH(MO_ORDER))$
    $MO_CLASS_LIST[memtop] = APPEND(MO_CLASS_LIST[memtop], moid)$
    $curr_idx = curr_idx + 1$
    $moid = AT(MO_ORDER, curr_idx)$
$END$

$ 
$  ݸñ̤μºݤΥꡤäʾǡ
$  ARM MPUΥǾ֤ͤ
$  ARM MPUΥϡ32B~4GBϰϤ2Τ٤
$  ARGV[1]ºݤΥ
$  RESULTARM MPUΥǾ
$FUNCTION SEARCH_ARM_MPU_SIZE$
    $IF ARGV[1] <= 0$
        $RESULT = 0$
    $ELSE$
        $search_state = 0$
        $FOREACH bit_offset { 31,30,...,5 }$
            $compare_bit = 1 << bit_offset$
            $IF ((ARGV[1] & compare_bit) != 0)$
                $IF (search_state == 0)$
                    $result_size = compare_bit$
                    $search_state = 1$
                $ELIF (search_state == 1)$
                    $result_size = (result_size << 1)$
                    $search_state = 2$
                $END$
            $END$
        $END$
        $IF (search_state == 0)$
            $result_size = (1 << 5)$
        $ELIF (search_state == 1) && ((ARGV[1] & 0x1f) != 0)$
            $result_size = (result_size << 1)$
        $END$
        $RESULT = result_size$
    $END$
$END$

$ 
$  äϰʾǡ
$  ARM MPUΥ饤Ǿ֤ͤ
$  ARM MPUΥ饤ϡ32B~4GBϰϤ2Τ٤
$  ARGV[1]
$  RESULTARM MPUΥ饤Ǿ
$FUNCTION ARM_MPU_ALIGN$
    $compare_mask = 0x0f$
    $result_addr = ARGV[1] & (~compare_mask)$
    $IF ((ARGV[1] & compare_mask) != 0)$
       $result_addr = result_addr + 0x10$ 
    $END$
    $RESULT = result_addr$
$END$

$FUNCTION COMPARE_MO_SIZE$
    $RESULT = MO_BLOCK.SIZE[ARGV[1]] - MO_BLOCK.SIZE[ARGV[2]]$
$END$

$ 
$  äϤARM MPUΥ饤κ֤ͤ
$ 
$FUNCTION SEARCH_ARM_MPU_ALIGN$
    $IF ((ARGV[1] & 0x0f) != 0)$
        $ERROR$
            $FORMAT("error: not aligned. %x", ARGV[1])$$NL$
        $END$
    $END$
    $result_align = 0$
    $FOREACH bit_offset { 5,6,...,31 }$
        $compare_bit = 1 << bit_offset$
        $IF (!result_align && ((ARGV[1] & compare_bit) != 0))$
            $result_align = compare_bit$
        $END$
    $END$
    $IF !result_align$
        $result_align = 1 << 32$
    $END$
    $RESULT = result_align$
$END$

$FUNCTION COMPARE_NORMAL$
    $RESULT = ARGV[1] - ARGV[2]$
$END$

$FOREACH reg REG.ORDER$
    $MO_REG_LIST[reg] = {}$
$END$

$  =begin GENERATE_MEMINIB_TABLE
$FUNCTION GENERATE_MEMINIB_TABLE$
    /* generate meminib by target_mem.tf */
$  MO_BLOCK[moid]ꥪ֥Ȥ֤¤ؤñ
$  MO_BLOCK.SIZE[moid]MPUΥ褦˥饤󤷤
$  MO_BLOCK_LIST0ǤʤMO_BLOCKΥꥹ
$prev = -1$
$mo_block_top = -1$
$MO_LIST_CACHE = {}$
$FOREACH moid MO_START_LIST$
    $IF LENGTH(FIND(MO_MPROTECT_LIST, moid))$
        $IF (mo_block_top != -1) && (!MO.SRPW[prev] || !MO.SRPW[moid])$
            $MO_BLOCK.LIMITADDR[mo_block_top] = MO.LIMITADDR[prev]$
            $WARNING$pre MO_BLOCK.SIZE[$mo_block_top$] = $MO_BLOCK.LIMITADDR[mo_block_top] - MO_BLOCK.BASEADDR[mo_block_top]$$END$
            $MO_BLOCK.SIZE[mo_block_top] = SEARCH_ARM_MPU_SIZE(MO_BLOCK.LIMITADDR[mo_block_top] - MO_BLOCK.BASEADDR[mo_block_top])$
            $WARNING$MO_BLOCK.SIZE[$mo_block_top$] = $+MO_BLOCK.SIZE[mo_block_top]$$END$
            $IF (MO_BLOCK.SIZE[mo_block_top] > 0)$
                $MO_BLOCK_LIST = APPEND(MO_BLOCK_LIST, mo_block_top)$
                $MO_BLOCK.MO_LIST[mo_block_top] = MO_LIST_CACHE$
                $WARNING$MO_LIST[$mo_block_top$] = $MO_BLOCK.MO_LIST[mo_block_top]$$END$
                $WARNING$MO_BLOCK.SIZE[$mo_block_top$] = $+MO_BLOCK.SIZE[mo_block_top]$$END$
            $END$
            $MO_LIST_CACHE = {}$
        $END$
        $IF (mo_block_top == -1) || !MO.SRPW[moid] || !MO.SRPW[prev]$
            $MO_BLOCK.BASEADDR[moid] = MO.BASEADDR[moid]$
            $mo_block_top = moid$
        $END$
    $END$
    
    $prev = moid$
    $MO_LIST_CACHE = APPEND(MO_LIST_CACHE, moid)$
$END$
$MO_BLOCK.LIMITADDR[mo_block_top] = MO.LIMITADDR[prev]$
$WARNING$pre MO_BLOCK.SIZE[$mo_block_top$] = $MO_BLOCK.LIMITADDR[mo_block_top] - MO_BLOCK.BASEADDR[mo_block_top]$$END$
$MO_BLOCK.SIZE[mo_block_top] = SEARCH_ARM_MPU_SIZE(MO_BLOCK.LIMITADDR[mo_block_top] - MO_BLOCK.BASEADDR[mo_block_top])$
$WARNING$MO_BLOCK.SIZE[$mo_block_top$] = $+MO_BLOCK.SIZE[mo_block_top]$$END$
$IF (MO_BLOCK.SIZE[mo_block_top] > 0)$
    $MO_BLOCK_LIST = APPEND(MO_BLOCK_LIST, mo_block_top)$
    $MO_BLOCK.MO_LIST[mo_block_top] = MO_LIST_CACHE$
    $WARNING$MO_LIST[$mo_block_top$] = $MO_BLOCK.MO_LIST[mo_block_top]$$END$
    $WARNING$MO_BLOCK.SIZE[$mo_block_top$] = $+MO_BLOCK.SIZE[mo_block_top]$$END$
$END$
$MO_LIST_CACHE = {}$

$WARNING$MO_BLOCK_LIST: $MO_BLOCK_LIST$$END$
$ 
$  suppresszeroɥ쥹0б륨ȥϤʤ
$  MO.SUPPRESSLIMIT[moid]¥ɥ쥹ΥȥϤʤ
$  MO_REG_LIST[reg]reg°MOΥꥹ
$  MO_NONREG_LISTreg°ʤMOΥꥹ
$  CONTEXT_LISTregmemreg°ʤMOˤpass3ǤΥ󥯽¤٤ꥹ
$  REG.REALBASE[reg]MPUΥ饤褦˥饤󤷤regƬ
$prev = 0$
$reg_state = -1$
$nonreg_no = 0$
$CONTEXT_LIST = {}$
$MO_TOP_SRPW = -1$
$MO_TOP_PROTECT = -1$
$FOREACH moid SORT(MO_BLOCK_LIST, "MO_BLOCK.BASEADDR")$
    $IF LENGTH(MO.MEMREG[moid])$
        $MO_REG_LIST[MO.MEMREG[moid]] = APPEND(MO_REG_LIST[MO.MEMREG[moid]], moid)$
        $IF ((LENGTH(current_reg) && (current_reg != MO.MEMREG[moid])) || (reg_state != 1))$
            $CONTEXT_LIST = APPEND(CONTEXT_LIST, VALUE("REG",MO.MEMREG[moid]))$
            $reg_state = 1$
            $current_reg = MO.MEMREG[moid]$
        $END$
        $WARNING$// append $moid$ to $MO.MEMREG[moid]$$END$

    $ELSE$
        $IF reg_state != 0$
            $CONTEXT_LIST = APPEND(CONTEXT_LIST, VALUE("NONREG",+nonreg_no))$
            $reg_state = 0$
            $nonreg_no = nonreg_no + 1$
        $END$
        $MO_NONREG_LIST[nonreg_no] = APPEND(MO_NONREG_LIST[nonreg_no], moid)$
    $END$

    $IF !LENGTH(REG.REALBASE[MO.MEMREG[moid]])$
        $REG.REALBASE[MO.MEMREG[moid]] = ARM_MPU_ALIGN(MO_BLOCK.BASEADDR[moid])$
    $END$

    $prev = moid$
$END$

$WARNING$context list : $CONTEXT_LIST$$END$

$  MO_SIZE_REG_LIST[reg]reg°MO򥵥¤٤ꥹ
$  MO.REALBASE[moid]MO֤
$FOREACH reg REG_ORDER$
    $MO_SIZE_REG_LIST[reg] = LSORT(MO_REG_LIST[reg], "COMPARE_MO_SIZE")$
    $WARNING$// $FORMAT("{ %x:%x } ", REG.REALBASE[reg], SEARCH_ARM_MPU_ALIGN(REG.REALBASE[reg]))$ $END$

$   // 
    $FOREACH size SIZE_LIST$
        $MO_LIST_SIZE[MO.SIZE[moid]] = {}$
    $END$
    $SIZE_LIST = {}$
    $MO_SIZEORDER_LIST_REG[reg] = {}$
    $REG.LIMIT[reg] = 0$

$   // ȤMO_LIST_SIZE[size]moidʬ
$   // SIZE_LISTʬव줿size򥵥¤٤ꥹ
    $FOREACH moid MO_SIZE_REG_LIST[reg]$
        $WARNING${ $moid$, $MO_BLOCK.SIZE[moid]$ },$END$
    
        $IF !LENGTH(FIND(SIZE_LIST, MO_BLOCK.SIZE[moid]))$
            $MO_LIST_SIZE[MO_BLOCK.SIZE[moid]] = { moid }$
            $SIZE_LIST = APPEND(SIZE_LIST, MO_BLOCK.SIZE[moid])$
        $ELSE$
            $MO_LIST_SIZE[MO_BLOCK.SIZE[moid]] = APPEND(MO_LIST_SIZE[MO_BLOCK.SIZE[moid]], moid)$
        $END$
    $END$
    $NL$
    $SIZE_LIST = LSORT(SIZE_LIST, "COMPARE_NORMAL")$

    $base = REG.REALBASE[reg]$
    $WARNING$// !base=$base$: size_list=$SIZE_LIST$$END$
    $WHILE (LENGTH(SIZE_LIST) > 0)$
$       // Хեå
        $IF (base >= (REG.BASE[reg] + REG.SIZE[reg]))$
            $ERROR$
                $FORMAT("error: overflow reg[%s], %x", reg, base)$
            $END$
            $DIE()$
        $END$
$       // alignMOƬϤ򥢥饤󤷤
        $align = SEARCH_ARM_MPU_ALIGN(base)$
        $WARNING$$FORMAT("!base=%x,align=%x: ", base, align)$ $SIZE_LIST$$NL$$END$
$       // 饤󤷤Ϥֲǽʥ򥵡
        $search_state = 0$
        $idx = -1$
        $WHILE ((idx < (LENGTH(SIZE_LIST) - 1)) && (search_state == 0))$
            $idx = idx + 1$
            $size = AT(SIZE_LIST, idx)$
            $IF (size >= align)$
                $search_state = 1$
            $END$
        $END$
        $IF (search_state == 0)$
            $idx = idx + 1$
        $END$

$       // MOκ֤
        $TMP_LIST = {}$
        $idx0_flg = 1$
$       // size == alignʤФΥMO򤳤Ϥ֤
        $IF (size == align)$
            $FOREACH moid MO_LIST_SIZE[size]$
                $IF idx0_flg$
                    $WARNING$// push {moid=$moid$,size=$size$}$NL$$END$
                    $MO.REALBASE[moid] = base$
                    $MO_SIZEORDER_LIST_REG[reg] = APPEND(MO_SIZEORDER_LIST_REG[reg], moid)$
                    $idx0_flg = 0$
                $ELSE$
                    $TMP_LIST = APPEND(TMP_LIST, moid)$
                $END$
            $END$
$           // MO_LIST_SIZEƬMO
            $MO_LIST_SIZE[size] = TMP_LIST$
$           // MO_LIST_SIZEˤʤä
            $IF (LENGTH(MO_LIST_SIZE[size]) == 0)$
                $FOREACH sz SIZE_LIST$
                    $IF (sz != size)$
                        $TMP_LIST = APPEND(TMP_LIST, sz)$
                    $END$
                $END$
$               // SIZE_LIST餽Υ
                $SIZE_LIST = TMP_LIST$
            $END$
            $WARNING$// size_list update#1 : $MO_LIST_SIZE[size]$$NL$$END$
$           // ƬϤ򹹿
            $base = base + size$
$           // regνλϤ򹹿
            $IF REG.LIMIT[reg] < base$
                $REG.LIMIT[reg] = base$
            $END$

$       // size > alignʤФ1ʳMO򤳤Ϥ֤
        $ELIF (idx > 0)$
            $size = AT(SIZE_LIST, idx - 1)$
            $FOREACH moid MO_LIST_SIZE[size]$
                $IF idx0_flg$
                    $WARNING$// push {moid=$moid$,size=$size$}$NL$$END$
                    $MO.REALBASE[moid] = base$
                    $MO_SIZEORDER_LIST_REG[reg] = APPEND(MO_SIZEORDER_LIST_REG[reg], moid)$
                    $idx0_flg = 0$
                $ELSE$
                    $TMP_LIST = APPEND(TMP_LIST, moid)$
                $END$
            $END$
$           // MO_LIST_SIZEƬMO
            $MO_LIST_SIZE[size] = TMP_LIST$
$           // MO_LIST_SIZEˤʤä
            $IF (LENGTH(MO_LIST_SIZE[size]) == 0)$
                $FOREACH sz SIZE_LIST$
                    $IF (sz != size)$
                        $TMP_LIST = APPEND(TMP_LIST, sz)$
                    $END$
                $END$
$               // SIZE_LIST餽Υ
                $SIZE_LIST = TMP_LIST$
            $END$
            $WARNING$// size_list update#2 : $MO_LIST_SIZE[size]$$NL$$END$
$           // ƬϤ򹹿
            $base = base + size$
$           // regνλϤ򹹿
            $IF REG.LIMIT[reg] < base$
                $REG.LIMIT[reg] = base$
            $END$

$       // sizeʺ͡ < alignʤФΥMO򤳤Ϥ֤
        $ELIF (size < align)$
            $FOREACH moid MO_LIST_SIZE[size]$
                $IF idx0_flg$
                    $WARNING$// push {moid=$moid$,size=$size$}$NL$$END$
                    $MO.REALBASE[moid] = base$
                    $MO_SIZEORDER_LIST_REG[reg] = APPEND(MO_SIZEORDER_LIST_REG[reg], moid)$
                    $idx0_flg = 0$
                $ELSE$
                    $TMP_LIST = APPEND(TMP_LIST, moid)$
                $END$
            $END$
$           // MO_LIST_SIZEƬMO
            $MO_LIST_SIZE[size] = TMP_LIST$
$           // MO_LIST_SIZEˤʤä
            $IF (LENGTH(MO_LIST_SIZE[size]) == 0)$
                $FOREACH sz SIZE_LIST$
                    $IF (sz != size)$
                        $TMP_LIST = APPEND(TMP_LIST, sz)$
                    $END$
                $END$
$               // SIZE_LIST餽Υ
                $SIZE_LIST = TMP_LIST$
            $END$
            $WARNING$// size_list update#3 : $MO_LIST_SIZE[size]$$NL$$END$
$           // ƬϤ򹹿
            $base = base + size$
$           // regνλϤ򹹿
            $IF REG.LIMIT[reg] < base$
                $REG.LIMIT[reg] = base$
            $END$

$       // sizeʺǾ͡ > alignʤϤƷ׻
        $ELSE$
            $WARNING$$FORMAT("size = %d, pre base = %x", size, base)$$NL$$END$
            $pre_base = base$
            $IF ((base % size) != 0)$
$               // sizeΥӥåȤ겼̥ӥåȤ򤹤٤0ˤ                
                $base = ((base / size) * size) + size$
            $ELSE$
$               // sizeΥӥåȤ겼̥ӥåȤ򤹤٤0ˤ                
                $base = ((base / size) * size)$
            $END$
            $WARNING$$FORMAT("post base = %x", base)$$NL$$END$
            $IF pre_base == base$
                $ERROR$$FORMAT("Error: base is not updated")$$NL$$END$
                $DIE()$
            $END$
        $END$
    $END$
$END$

$  
$  MO_MEMTOP_REAL_LIST֤MEMTOP_LIST
$FOREACH ctx CONTEXT_LIST$
    $IF EQ(ctx, "REG")$
        $WARNING$$FORMAT("ctx is %s: %d", ctx, +ctx)$$END$
        $TMP_LIST = MO_SIZEORDER_LIST_REG[ctx]$
    $ELIF EQ(ctx, "NONREG")$
        $WARNING$$FORMAT("ctx is %s: %d", ctx, +ctx)$$END$
        $TMP_LIST = MO_NONREG_LIST[ctx]$
    $ELSE$
        $ERROR$error: context$END$
        $DIE()$
    $END$
    $WARNING$ list : $TMP_LIST$$END$
    $FOREACH moid TMP_LIST$
        $MO_MEMTOP_REAL_LIST = APPEND(MO_MEMTOP_REAL_LIST, moid)$
    $END$
$END$

/*$NL$
$FOREACH moid MO_MEMTOP_REAL_LIST$
    $WARNING$$FORMAT("label is %s: base=%x, size=%x(%d)", MO.MLABEL[moid], MO.REALBASE[moid], MO_BLOCK.SIZE[moid], MO_BLOCK.SIZE[moid])$$NL$$END$
    $FORMAT("label is %s: base=%x, size=%x(%d)", MO.MLABEL[moid], MO.REALBASE[moid], MO_BLOCK.SIZE[moid], MO_BLOCK.SIZE[moid])$$NL$
$END$
*/$NL$

$ 
$  ꥪ֥Ƚ֥å˽Ϥʤȥη
$ 
$  suppresszeroɥ쥹0б륨ȥϤʤ
$  MO.SUPPRESSLIMIT[moid]¥ɥ쥹ΥȥϤʤ
$tsize_meminib = LENGTH(MO_START_LIST) * 2 + 1$
$tnum_meminib = LENGTH(MO_MEMTOP_REAL_LIST) * 2 + 1$
$tnum_suppresslimit = 0$

$WARNING$Difinition of SUPPRESSLIMIT$END$
$prev = 0$
$FOREACH moid MO_MEMTOP_REAL_LIST$
    $IF MO.LINKER[moid]$
        $base = MO.REALBASE[moid]$
        $IF !LENGTH(MO_BLOCK.MO_LIST[moid])$
            $ERROR$MO_LIST[$moid$] is empty$END$
        $END$
        $FOREACH mo MO_BLOCK.MO_LIST[moid]$
            $IF mo != AT(MO_BLOCK.MO_LIST[moid], LENGTH(MO_BLOCK.MO_LIST[moid]) - 1)$
                $MO.SUPPRESSLIMIT_REAL[mo] = 1$
                $tnum_suppresslimit = tnum_suppresslimit - 1$
            $END$
            $IF MO.BASEADDR[mo] != MO.LIMITADDR[mo]$
                $MO_MEMTOP_REAL_ORDER = APPEND(MO_MEMTOP_REAL_ORDER, mo)$
            $ELSE$
                $tnum_suppresslimit = tnum_suppresslimit - 1$
            $END$
        $END$
    $ELSE$
        $base = MO.BASEADDR[moid]$
        $MO_MEMTOP_REAL_ORDER = APPEND(MO_MEMTOP_REAL_ORDER, moid)$
    $END$

    $IF !prev$
        $IF base == 0$
            $suppresszero_real = 1$
            $tnum_suppresslimit = tnum_suppresslimit - 1$
        $END$
    $ELSE$
        $IF MO.LINKER[prev]$
            $prev_limit = MO.REALBASE[prev] + MO_BLOCK.SIZE[prev]$
            $IF LENGTH(MO_BLOCK.MO_LIST[prev])$
                $prev = AT(MO_BLOCK.MO_LIST[prev],LENGTH(MO_BLOCK.MO_LIST[prev]) - 1)$
            $END$
        $ELSE$
            $prev_limit = MO_BLOCK.LIMITADDR[prev]$
        $END$
        $WARNING$$FORMAT("prev = %d", prev)$$END$
        $WARNING$$FORMAT("prev_limit = 0x%x", prev_limit)$$END$
        $WARNING$$FORMAT("base = 0x%x", base)$$END$
        $IF base == prev_limit$
            $MO.SUPPRESSLIMIT_REAL[prev] = 1$
            $tnum_suppresslimit = tnum_suppresslimit - 1$
        $END$
    $END$

    $prev = moid$
$END$
$IF prev_limit == 0$
    $IF MO.LINKER[prev] && LENGTH(MO_BLOCK.MO_LIST[prev])$
        $prev = AT(MO_BLOCK.MO_LIST[prev],LENGTH(MO_BLOCK.MO_LIST[prev]) - 1)$
    $END$
    $MO.SUPPRESSLIMIT_REAL[prev] = 1$
    $tnum_suppresslimit = tnum_suppresslimit - 1$
$END$

$tnum_meminib = LENGTH(MO_MEMTOP_REAL_ORDER) * 2 + 1$
$tnum_meminib = tnum_meminib + tnum_suppresslimit$

$  memtop_tableǻȤ٥
$FOREACH moid MO_MEMTOP_REAL_ORDER$
    $IF MO.LINKER[moid]$
        extern char __start_$MO.MLABEL[moid]$;$NL$
        $IF !LENGTH(MO.SUPPRESSLIMIT_REAL[moid])$
            extern char __limit_$MO.MLABEL[moid]$;$NL$
        $END$
    $END$
$END$$NL$


$  tnum_meminib
const uint_t _kernel_tnum_meminib = $tnum_meminib$U;$NL$
$NL$

$  memtop_table
#if 0$NL$
void *const _kernel_memtop_table[$tsize_meminib$] = {$NL$
$IF !LENGTH(suppresszero_real)$
    $TAB$0,$NL$
$END$
$JOINEACH moid MO_MEMTOP_ORDER ",\n"$
    $IF MO.LINKER[moid]$
        $TAB$&__start_$MO.MLABEL[moid]$
        $SPC$/* $FORMAT("base=%x, size=%x(%d)", MO.BASEADDR[moid], (MO.LIMITADDR[moid] - MO.BASEADDR[moid]), (MO.LIMITADDR[moid] - MO.BASEADDR[moid]))$ */
        $IF !LENGTH(MO.SUPPRESSLIMIT[moid])$
            ,$NL$$TAB$&__limit_$MO.MLABEL[moid]$
            $SPC$/* $FORMAT("%x", MO.LIMITADDR[moid])$ */
        $END$
    $ELSE$
        $TAB$(void *)($MO.BASE[moid]$)
        $SPC$/* $FORMAT("%x", MO.BASEADDR[moid])$ */
        $IF !LENGTH(MO.SUPPRESSLIMIT[moid])$
            ,$NL$$TAB$(void *)(((char *)($MO.BASE[moid]$)) + ($MO.SIZE[moid]$))
            $SPC$/* $FORMAT("%x", MO.LIMITADDR[moid])$ */
        $END$
    $END$
$END$$NL$
};$NL$
#endif$NL$
$NL$

$  memtop_table
void *const _kernel_memtop_table[$tsize_meminib$] = {$NL$
$IF !LENGTH(suppresszero_real)$
    $TAB$0,$NL$
$END$
$JOINEACH moid MO_MEMTOP_REAL_ORDER ",\n"$
    $IF MO.LINKER[moid]$
        $TAB$&__start_$MO.MLABEL[moid]$
        $IF LENGTH(MO.REALBASE[moid])$
            $SPC$/* $FORMAT("base=%x, size=%x(%d)", MO.REALBASE[moid], MO_BLOCK.SIZE[moid], MO_BLOCK.SIZE[moid])$ */
        $END$
        $IF !LENGTH(MO.SUPPRESSLIMIT_REAL[moid])$
            ,$NL$$TAB$&__limit_$MO.MLABEL[moid]$
        $END$
    $ELSE$
        $TAB$(void *)($MO.BASE[moid]$)
        $SPC$/* $FORMAT("%x", MO.BASE[moid])$ */
        $IF !LENGTH(MO.SUPPRESSLIMIT_REAL[moid])$
            ,$NL$$TAB$(void *)(((char *)($MO.BASE[moid]$)) + ($MO.SIZE[moid]$))
            $SPC$/* $FORMAT("%x", MO.LIMITADDR[moid])$ */
        $END$
    $END$
$END$$NL$
};$NL$
$NL$

$  meminib_table
const MEMINIB _kernel_meminib_table[$tsize_meminib$] = {$NL$
$IF !LENGTH(suppresszero)$
    $TAB${ TA_NULL, 0, 0, 0 },$NL$
$END$
$JOINEACH moid MO_MEMTOP_REAL_ORDER ",\n"$
    $TAB${
    $IF MO.TYPE[moid] == TOPPERS_USTACK$
        $SPC$TOPPERS_USTACK|($MO.MEMATR[moid]$),
        $SPC$$MO.ACPTN4[moid]$,
        $IF MO.TSKID[moid] != 0$
            $SPC$(ACPTN)(&_kernel_tcb_table[$MO.TSKID[moid]$ - 1]),
        $ELSE$
            $SPC$(ACPTN)(NULL),
        $END$
        $SPC$0
    $ELSE$
        $IF MO.TYPE[moid] == TOPPERS_ATTMEM$
            $SPC$TOPPERS_ATTMEM|($MO.MEMATR[moid]$),
        $ELSE$
            $SPC$TOPPERS_ATTSEC|($MO.MEMATR[moid]$),
        $END$
        $SPC$$MO.ACPTN4[moid]$,
        $SPC$$MO.ACPTN1[moid]$,
        $SPC$$MO.ACPTN2[moid]$
    $END$
    $SPC$}
    $IF !LENGTH(MO.SUPPRESSLIMIT_REAL[moid])$
        ,$NL$$TAB${ TA_NULL, 0, 0, 0 }
    $END$
$END$$NL$
};$NL$

$ MO_REAL_ORDER֤֤MO¤٤ꥹ
$FOREACH memtop MO_MEMTOP_REAL_ORDER$
    // $memtop$ : $MO_CLASS_LIST[memtop]$,$NL$
    $FOREACH moid MO_CLASS_LIST[memtop]$
        $MO_REAL_ORDER = APPEND(MO_REAL_ORDER, moid)$
    $END$
$END$

$ 
$  ʣΥˤޤݸñ̤ξ硤
$  ݸñ̤ƬMEMTOP_ORDERϿȤϸ¤ʤΤǡ
$  ݸñ̤ˤrealbasesize򡤥ݸñ̤
$  ƬΥꥪ֥Ȥ°Ϳ
$ 
$plabel_moid = 0$
$FOREACH moid MO_ORDER$
    $IF (MO.SEFLAG[moid] & 0x10) != 0$
        $plabel_moid = moid$
        $WARNING$$FORMAT("plabel is %d", moid)$$END$
    $END$
    $IF LENGTH(MO_BLOCK.SIZE[moid])$
        $IF !plabel_moid$
            $ERROR$$FORMAT("error: not exist within plabel: mo = %d", moid)$$END$
        $END$
        $MO.REALBASE[plabel_moid] = MO.REALBASE[moid]$
        $MO.SIZE[plabel_moid] = MO_BLOCK.SIZE[moid]$
    $END$
    $IF (MO.SEFLAG[moid] & 0x20) != 0$
        $plabel_moid = 0$
    $END$
$END$
$END$
$  =end GENERATE_MEMINIB_TABLE

$INCLUDE "kernel/kernel_mem.tf"$


$ 
$  arch/gcc/ldscript.tfΥåȰ¸
$ 
$FUNCTION GENERATE_MEMORY$
    $NOOP()$
$END$


$FUNCTION GENERATE_OUTPUT$
    OUTPUT_FORMAT("elf32-littlearm", "elf32-bigarm","elf32-littlearm")$NL$
    OUTPUT_ARCH(arm)$NL$
    STARTUP(start.o)$NL$
    $IF TOPPERS_RAM_DEBUG$
        ENTRY(_start)$NL$
    $END$
    $NL$
$END$

$FUNCTION GENERATE_PROVIDE$
    PROVIDE(hardware_init_hook = 0);$NL$
    PROVIDE(software_init_hook = 0);$NL$
    PROVIDE(software_term_hook = 0);$NL$
    PROVIDE(_kernel_bsssecinib_table = 0);$NL$
    PROVIDE(_kernel_tnum_bsssec = 0);$NL$
    PROVIDE(_kernel_datasecinib_table = 0);$NL$
    PROVIDE(_kernel_tnum_datasec = 0);$NL$
    $NL$

    $IF LENGTH(DOM.ID_LIST)$
        $FOREACH domid DOM.ID_LIST$
$   RXΰѡ
            PROVIDE(__start_text_$DOM.LABEL[domid]$ = 0xffffffff);$NL$
            PROVIDE(__limit_text_$DOM.LABEL[domid]$ = 0xffffffff);$NL$
$   Rΰѡ
            PROVIDE(__start_rodata_$DOM.LABEL[domid]$ = 0xffffffff);$NL$
            PROVIDE(__limit_rodata_$DOM.LABEL[domid]$ = 0xffffffff);$NL$
$   RWXΰѡ
            PROVIDE(__start_ram_$DOM.LABEL[domid]$ = 0xffffffff);$NL$
            PROVIDE(__limit_ram_$DOM.LABEL[domid]$ = 0xffffffff);$NL$
$   ͭ꡼ѥ饤
            PROVIDE($FORMAT("__start_ram_%s_%x_%x", DOM.LABEL[domid], +DEFAULT_ACPTN[domid], +TACP_SHARED)$ = 0xffffffff);$NL$
            PROVIDE($FORMAT("__limit_ram_%s_%x_%x", DOM.LABEL[domid], +DEFAULT_ACPTN[domid], +TACP_SHARED)$ = 0xffffffff);$NL$
$  ͭΰ
            PROVIDE(__start_text_$DOM.LABEL[TDOM_NONE]$ = 0xffffffff);$NL$
            PROVIDE(__limit_text_$DOM.LABEL[TDOM_NONE]$ = 0xffffffff);$NL$
            PROVIDE(__start_rodata_$DOM.LABEL[TDOM_NONE]$ = 0xffffffff);$NL$
            PROVIDE(__limit_rodata_$DOM.LABEL[TDOM_NONE]$ = 0xffffffff);$NL$
            PROVIDE(__start_ram_$DOM.LABEL[TDOM_NONE]$ = 0xffffffff);$NL$
            PROVIDE(__limit_ram_$DOM.LABEL[TDOM_NONE]$ = 0xffffffff);$NL$
        $END$
        $NL$
    $END$$NL$
$   ͭ꡼ѥ饤ΰ
    PROVIDE(__start_srpw_all = 0xffffffff);$NL$
    PROVIDE(__limit_srpw_all = 0xffffffff);$NL$
    $NL$
$END$

$ 
$  ͥ뤬ʤϤ
$  åȰ¸ɬפʥ
$ 
$FUNCTION GENERATE_SECTION_FIRST$
    $TAB$.startup : {$NL$
    $IF TOPPERS_RAM_DEBUG$
        $TAB$$TAB$KEEP(*(.vector))$NL$
    $ELSE$
        $TAB$$TAB$*(.vector)$NL$
    $END$
    $TAB$$TAB$start.o(.text_kernel)$NL$
    $TAB$$TAB$start.o(*.text*)$NL$
    $IF TOPPERS_RAM_DEBUG$
        $TAB$} > $REG.REGNAME[STANDARD_RAM]$$NL$
    $ELSE$
        $TAB$} > $REG.REGNAME[STANDARD_ROM]$$NL$
    $END$
    $NL$
	$TAB$.ARM.extab : { *(.ARM.extab* .gnu.linkonce.armextab.*) }$NL$
	$TAB$__exidx_start = .;$NL$
	$TAB$.ARM.exidx : { *(.ARM.exidx* .gnu.linkonce.armexidx.*) }$NL$
	$TAB$__exidx_end = .;$NL$
$END$

$ 
$  ڡȥ饤Ȥ
$  1Bǥ饤󤷤Ƥ
$ 
$TARGET_PAGE_SIZE_STR = 1$
$TARGET_SEC_ALIGN_STR = 1$

$
$  󥫤ΤΥ󵭽Ҥ
$
$FUNCTION SECTION_DESCRIPTION$
	$IF EQ(ARGV[1], ".rodata")$
		$RESULT = "*.rodata *.rodata.* .rodata.str1.4"$
	$ELIF EQ(ARGV[1], ".bss")$
		$RESULT = "*.bss *.bss.* COMMON"$
	$ELIF EQ(ARGV[1], ".text")$
		$RESULT = "*.text *.text.* .glue_7t .glue_7"$
	$ELIF EQ(ARGV[1], ".data")$
		$RESULT = "*.data *.data.* vtable"$
	$ELSE$
		$RESULT = ARGV[1]$
	$END$
$END$

$TOPPERS_ATTMOD = TOPPERS_ATTSEC + 1$
$TOPPERS_MPFAREA = TOPPERS_ATTSEC + 2$

$INCLUDE "target/lm3sxxxx_gcc/ldscript.tf"$

$NL$


$ 
$  ͭΰν֥åݸɥᥤ֥åmem¸
$ 

$FILE "kernel_mem.c"$

$ 
$ ݸɥᥤƥȥ֥åΤ
$ 
$FUNCTION PREPARE_DOMINICTXB$
    $IF LENGTH(DOM.ID_LIST)$
        $FOREACH domid DOM.ID_LIST$
$   RXΰѡ
            extern char __start_text_$DOM.LABEL[domid]$;$NL$
            extern char __limit_text_$DOM.LABEL[domid]$;$NL$
$   Rΰѡ
            extern char __start_rodata_$DOM.LABEL[domid]$;$NL$
            extern char __limit_rodata_$DOM.LABEL[domid]$;$NL$
$   RWXΰѡ
            extern char __start_ram_$DOM.LABEL[domid]$;$NL$
            extern char __limit_ram_$DOM.LABEL[domid]$;$NL$
$   ͭ꡼ѥ饤
            extern char $FORMAT("__start_ram_%s_%x_%x", DOM.LABEL[domid], +DEFAULT_ACPTN[domid], +TACP_SHARED)$;$NL$
            extern char $FORMAT("__limit_ram_%s_%x_%x", DOM.LABEL[domid], +DEFAULT_ACPTN[domid], +TACP_SHARED)$;$NL$
        $END$
        $NL$
    $END$$NL$

$  ͭΰ
    extern char __start_text_$DOM.LABEL[TDOM_NONE]$;$NL$
    extern char __limit_text_$DOM.LABEL[TDOM_NONE]$;$NL$
    extern char __start_rodata_$DOM.LABEL[TDOM_NONE]$;$NL$
    extern char __limit_rodata_$DOM.LABEL[TDOM_NONE]$;$NL$
    extern char __start_ram_$DOM.LABEL[TDOM_NONE]$;$NL$
    extern char __limit_ram_$DOM.LABEL[TDOM_NONE]$;$NL$
$   ͭ꡼ѥ饤ΰ
    extern char __start_srpw_all;$NL$
    extern char __limit_srpw_all;$NL$
    $NL$
	extern const DOMINIB_INFO _kernel_dominib_info_tbl[];$NL$
$END$

$PREPARE_DOMINICTXB()$

$region_size = 32$
$region_size_mask = 0x04$
$WHILE (region_size <= (4*1024*1024*1024))$
    $hash_region_size_mask[region_size] = (region_size_mask << 1)$
    $region_size = region_size * 2$
    $region_size_mask = region_size_mask + 1$
$END$

const DOMINIB_INFO _kernel_dominib_info_tbl[TNUM_DOMID] ={$NL$
$dominib_info = SYMBOL("_kernel_dominib_info_tbl")$
$JOINEACH domid DOM.ID_LIST ",\n"$
    $TAB${$NL$
$   RXΰѡ
    $start_label = PEEK(dominib_info, 4)$
    $limit_label = PEEK(dominib_info + 4, 4)$
    $size = limit_label - start_label$
    $IF size != 0$
        $size = SEARCH_ARM_MPU_SIZE(size)$
        $TAB$$TAB$( (char *)&__start_text_$DOM.LABEL[domid]$ + 0x10 + 0x04 ), /* region 4 : $FORMAT("0x%x", start_label)$ */$NL$
        $TAB$$TAB$( TO_MPU_AP( MPU_AP_PRWUR ) | MPU_REGATR_C | MPU_REGATR_B | $hash_region_size_mask[size]$ | MPU_REGATR_ENABLE ), /* size=$size$ */$NL$
    $ELSE$
        $TAB$$TAB$(char *)( 0x14 ), /* region 4 */$NL$
        $TAB$$TAB$( 0 ), /* size=0 */$NL$
    $END$
$   RWXΰѡ
    $start_label = PEEK(dominib_info + 8, 4)$
    $limit_label = PEEK(dominib_info + 12, 4)$
    $size = limit_label - start_label$
    $IF size != 0$
        $size = SEARCH_ARM_MPU_SIZE(size)$
        $TAB$$TAB$( (char *)&__start_ram_$DOM.LABEL[domid]$ + 0x10 + 0x05 ),/* region 5 : $FORMAT("0x%x", start_label)$ */$NL$
        $TAB$$TAB$( TO_MPU_AP( MPU_AP_PURW ) | MPU_REGATR_C | MPU_REGATR_B | $hash_region_size_mask[size]$ | MPU_REGATR_ENABLE ), /* size=$size$ */$NL$
    $ELSE$
        $TAB$$TAB$(char *)( 0x15 ), /* region 5 */$NL$
        $TAB$$TAB$( 0 ), /* size=0 */$NL$
    $END$
$   ͭ꡼ѥ饤
    $start_label = PEEK(dominib_info + 16, 4)$
    $limit_label = PEEK(dominib_info + 20, 4)$
    $size = limit_label - start_label$
    $IF size != 0$
        $size = SEARCH_ARM_MPU_SIZE(size)$
        $TAB$$TAB$$FORMAT("( (char *)&__start_ram_%s_%x_%x + 0x10 + 0x06 )", DOM.LABEL[domid], +DEFAULT_ACPTN[domid], +TACP_SHARED)$,/* region 6 : $FORMAT("0x%x", start_label)$ */$NL$
        $TAB$$TAB$( TO_MPU_AP( MPU_AP_PURW ) | MPU_REGATR_C | MPU_REGATR_B | $hash_region_size_mask[size]$ | MPU_REGATR_ENABLE ), /* size=$size$ */$NL$
    $ELSE$
        $TAB$$TAB$(char *)( 0x16 ), /* region 6 */$NL$
        $TAB$$TAB$( 0 ), /* size=0 */$NL$
    $END$
    $TAB$}
    $dominib_info = dominib_info + 24$
$END$
,$NL$};$NL$
$NL$
$TNUM_SHARED_REGION = 3$
const uint_t tnum_shared_mem = $TNUM_SHARED_REGION * 2$;$NL$
char * const shared_meminib_table[$TNUM_SHARED_REGION * 2$] = {$NL$
    $shared_info = SYMBOL("shared_meminib_table")$
    $start_label = PEEK(shared_info, 4)$
    $limit_label = PEEK(shared_info + 4, 4)$
    $size = limit_label - start_label$
    $IF size != 0$
        $size = SEARCH_ARM_MPU_SIZE(size)$
        $TAB$$TAB$((char *)&__start_text_$DOM.LABEL[TDOM_NONE]$ + 0x10 + 0x00),$TAB$/* region 0 : $FORMAT("0x%x", start_label)$ */$NL$
        $TAB$$TAB$(char *)( TO_MPU_AP( MPU_AP_PRWUR ) | MPU_REGATR_S | MPU_REGATR_C | MPU_REGATR_B | $hash_region_size_mask[size]$ | MPU_REGATR_ENABLE ), /* size=$size$ */$NL$
    $ELSE$
        $TAB$$TAB$(char *)( 0x10 ), /* region 0 */$NL$
        $TAB$$TAB$(char *)( 0 ), /* size=0 */$NL$
    $END$
    $start_label = PEEK(shared_info + 8, 4)$
    $limit_label = PEEK(shared_info + 12, 4)$
    $size = limit_label - start_label$
    $IF size != 0$
        $size = SEARCH_ARM_MPU_SIZE(size)$
        $TAB$$TAB$((char *)&__start_ram_$DOM.LABEL[TDOM_NONE]$ + 0x10 + 0x01),$TAB$/* region 1 : $FORMAT("0x%x", start_label)$ */$NL$
        $TAB$$TAB$(char *)( TO_MPU_AP( MPU_AP_PURW ) | MPU_REGATR_S | MPU_REGATR_C | MPU_REGATR_B | $hash_region_size_mask[size]$ | MPU_REGATR_ENABLE ), /* size=$size$ */$NL$
    $ELSE$
        $TAB$$TAB$(char *)( 0x11 ), /* region 1 */$NL$
        $TAB$$TAB$(char *)( 0 ), /* size=0 */$NL$
    $END$
    $start_label = PEEK(shared_info + 16, 4)$
    $limit_label = PEEK(shared_info + 20, 4)$
    $size = limit_label - start_label$
    $IF size != 0$
        $size = SEARCH_ARM_MPU_SIZE(size)$
        $TAB$$TAB$((char *)&__start_srpw_all + 0x10 + 0x02),$TAB$/* region 2 : $FORMAT("0x%x", start_label)$ */$NL$
        $TAB$$TAB$(char *)( TO_MPU_AP( MPU_AP_PRWUR ) | MPU_REGATR_S | MPU_REGATR_C | MPU_REGATR_B | $hash_region_size_mask[size]$ | MPU_REGATR_ENABLE ), /* size=$size$ */$NL$
    $ELSE$
        $TAB$$TAB$(char *)( 0x12 ), /* region 2 */$NL$
        $TAB$$TAB$(char *)( 0 ), /* size=0 */$NL$
    $END$
};$NL$
$NL$


